package tictactoe;

import java.util.Scanner;

/**
 * TicTacToe The user ('X') plays against the computer ('O') The first player is
 * chosen randomly.
 *
 * @author Your Name
 */
public class TicTacToeGame {

    /** the game character symbol for the player */
    public final char PLAYER = 'X';
    /** the game character symbol for the computer  */
    public final char COMPUTER = 'O';
    /** the game character symbol for an empty place on the board */
    public final char EMPTY = '-';
    /** Use for reading input from the user */
    Scanner in = new Scanner(System.in);

    /**
     * Plays the game of TicTacToe. Stops when either 1) a player wins or 2) no
     * spaces are left on the board.
     */
    public void play() {
        // Declare and create the board    
        openingGreeting();  // Greeting   
        // Pick starting player     
        // Initialize the board
        // Print the board

        int moves = 0;           // used to control game loop
        boolean hasWon = false;  // used to control game loop

        // game loop over moves and hasWon. In the loop:
        //    Have user or computer take their turn
        //    Print the board
        //    Check to see if anyone has won (update hasWon)
        //    swap players
        //    increment the moves
        // 

        if (!hasWon) {
            System.out.println("No one has won.");
        }
    }

    /**
     * Welcome the player
     */
    public void openingGreeting() {
        System.out.println("\nWELCOME TO TICTACTOE\n");
        System.out.println("You will be X, the computer will be O.");
        System.out.println("The starting player will be picked randomly.");
        System.out.println("Enjoy the game and good luck!\n");

    }

    /**
     * Initialize the values in the board to all blanks (EMPTY). Note, each
     * board position will eventually be either: 'X' - this is the user (PLAYER)
     * 'O' - this is the computer (COMPUTER) ' ' - a space indicates the
     * position is empty (EMPTY)
     *
     * @param board
     */
    public void initBoard(char[][] board) {
        // Loop over rows and columns of the board, setting each to EMPTY
        // YOUR CODE GOES HERE
    }

    /**
     * Swap the current player. That is, if the current player is 'X', it is
     * swapped to be 'O', and vice versa.
     *
     * @param curPlayer the currentPlayer
     * @return the new current player
     */
    public char swapPlayer(char curPlayer) {
        if (curPlayer == PLAYER) {
            curPlayer = COMPUTER;
        } else {
            curPlayer = PLAYER;
        }
        return curPlayer;
    }

    /**
     * Randomly pick which player (user or computer) goes first. Set the
     * currentPlayer to the first player. It is assumed that the user is always
     * "X" and the computer is always "O".
     *
     * @return the first player
     */
    public char initPlayer() {
        System.out.println("You are X and the computer is O.");
        char currentPlayer;
        if (Math.random() < .5) {
            currentPlayer = PLAYER;
            System.out.println("You are the first player.");
        } else {
            currentPlayer = COMPUTER;
            System.out.println("The computer is the first player.");
        }
        return currentPlayer;
    }

    /**
     * Chooses which position the computer will play. Sets that position of the
     * board to "O"
     *
     * @param board the board
     */
    public void computerTurn(char[][] board) {
        // YOUR CODE GOES HERE - 
        //         Pick some strategy (doesn't have to be smart!)
    }

    /**
     * Have the user choose which position to play. Sets that position of the
     * board to "X"
     *
     * @param board the board
     */
    public void userTurn(char[][] board) {
        int row = -1, col = -1;
        // COMPLETE THE CODE
        // Prompt user for row and column, making sure they enter 
        //   proper values (by calling method readValue twice).  
        System.out.println("\nIt is your turn.");

        // If that location is already taken, you need to ask again. 
        // Use a loop for this!

        // Once they have entered a row and column, replace
        // that item in the board with the PLAYER character.
        board[row][col] = PLAYER;
    }

    /**
     * Utility method to prompt user for a value in the range of 0 to 2 It makes
     * sure that the user enters a number between 0 and 2. If not, it loops and
     * asks for another input.
     *
     * @return the value of the row or column
     */
    public int readValue() {
        int val = -1;
        while (true) {
            val = in.nextInt();
            if (val < 0 || val > 2) {
                System.out.println("You have not entered a value in the "
                        + "range 0 to 2. Please try again.");
            } else {
                break;
            }
        }
        return val;
    }

    /**
     * Checks to see if the currentPlayer has won.
     *
     * @param board the board
     * @param currentPlayer the currentPlayer
     * @return true if the currentPlayer has won.
     */
    public boolean checkWin(char[][] board, char currentPlayer) {
        // the winning sequence: 
        String seqWin = "" + currentPlayer + currentPlayer + currentPlayer;
        boolean hasWon = false;
        String seq = "";

        // here is how you might check the rows
        for (int i = 0; i < board.length; i++) {
            seq = "";
            for (int j = 0; j < board.length; j++) {
                seq += board[i][j];
            }
            if (seq.equals(seqWin)) {
                hasWon = true;
            }
        }

        // check cols - ADD YOUR CODE GOES HERE

        // check diags - ADD YOUR CODE GOES HERE


        // Say who has won:
        if (hasWon) {
            if (currentPlayer == PLAYER) {
                System.out.println("Congratulations - you have won!");
            } else {
                System.out.println("Sorry, the computer won and you lost. "
                        + "\nBetter luck next time");
            }
        }
        return hasWon;
    }

    /**
     * Print the board. You should have a heading to show the column indices.
     * Each row should have a row index.
     *
     * @param board
     */
    public void printBoard(char[][] board) {
        // YOUR CODE GOES HERE
    }
}
